// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "RiSCAN2D.h"

#include "MainFrm.h"
#include "RiSCAN2DDoc.h"
#include "RiSCAN2DView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_LOGGING, OnLogging)
    ON_BN_CLICKED(IDC_ENVELOPE, OnEnvelope)
	ON_WM_MOVING()
	ON_WM_SIZING()
	ON_WM_ACTIVATE()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
  	ON_COMMAND_EX(ID_VIEW_TOOLBOX, OnBarCheck)
  	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBOX, OnUpdateControlBarMenu)
   	ON_UPDATE_COMMAND_UI(ID_INDICATOR_GRID, OnUpdateStatus)
    ON_UPDATE_COMMAND_UI(ID_INDICATOR_ZOOM, OnUpdateZoom)
    ON_UPDATE_COMMAND_UI(ID_INDICATOR_ROTATE, OnUpdateRotate)
    ON_UPDATE_COMMAND_UI(ID_INDICATOR_DIMENSION, OnUpdateDimension)
    ON_UPDATE_COMMAND_UI(ID_INDICATOR_LINES, OnUpdateLines)
END_MESSAGE_MAP()

static UINT indicators[] =
{
//	ID_SEPARATOR,           // status line indicator
    ID_INDICATOR_ROTATE,
    ID_INDICATOR_ZOOM,
    ID_INDICATOR_GRID,
    ID_INDICATOR_DIMENSION,
    ID_INDICATOR_LINES,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

    {
        // Create ToolBox dialog
        if (!m_wndToolBox.Create(this, IDD_TOOLBOX,
		    	CBRS_RIGHT | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_HIDE_INPLACE,
			    ID_VIEW_TOOLBOX))
    	{
	    	TRACE0("Failed to create dialog bar m_wndReflPos\n");
		    return -1;		// fail to create
	    }

    	m_wndToolBox.EnableDocking(CBRS_ALIGN_RIGHT);
	    EnableDocking(CBRS_ALIGN_ANY);
    	DockControlBar(&m_wndToolBox);

        CDataExchange DX(&m_wndToolBox, FALSE);
        DDX_Control(&DX, IDC_LOGGING, m_wndLog);
        DDX_Control(&DX, IDC_ENVELOPE, m_wndEnvelope);
    }

    CenterWindow();

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
    cs.cx = 800;
    cs.cy = 600;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
/*************************************************************************
 *
 * void OnUpdateStatus(CCmdUI* pCmdUI)
 *
 * Parameters:
 *
 * CCmdUI* pCmdUI       - This object represents the menu item or toolbar
 *                        button or other user-interface object that
 *                        generated the command
 *
 * Return value: 
 *
 * Description:
 *
 * This function updates the status bar.
 * 
 *************************************************************************/
void CMainFrame::OnUpdateStatus(CCmdUI *pCmdUI)
{
    pCmdUI->Enable(TRUE);
	CString str;
    CRiSCAN2DDoc* pDoc = (CRiSCAN2DDoc*)GetActiveDocument();
    if (pDoc->m_dGrid[pDoc->m_nCurrentGrid] == 0)
        str = _T(" Grid Size :   OFF");
    else
        str.Format(_T(" Grid Size :   %.1f m"), pDoc->m_dGrid[pDoc->m_nCurrentGrid]);
	pCmdUI->SetText(str); 
}

/*************************************************************************
 *
 * void OnUpdateZoom(CCmdUI* pCmdUI)
 *
 * Parameters:
 *
 * CCmdUI* pCmdUI       - This object represents the menu item or toolbar
 *                        button or other user-interface object that
 *                        generated the command
 *
 * Return value: 
 *
 * Description:
 *
 * This function updates the status bar.
 * 
 *************************************************************************/
void CMainFrame::OnUpdateZoom(CCmdUI *pCmdUI)
{
    pCmdUI->Enable(TRUE);
	CString str;
    CRiSCAN2DDoc* pDoc = (CRiSCAN2DDoc*)GetActiveDocument();
    str.Format(_T(" Zoom Factor :   %.2f"), pDoc->m_dZoom);
	pCmdUI->SetText(str); 
}


/*************************************************************************
 *
 * void OnUpdateRotate(CCmdUI* pCmdUI)
 *
 * Parameters:
 *
 * CCmdUI* pCmdUI       - This object represents the menu item or toolbar
 *                        button or other user-interface object that
 *                        generated the command
 *
 * Return value: 
 *
 * Description:
 *
 * This function updates the status bar.
 * 
 *************************************************************************/
void CMainFrame::OnUpdateRotate(CCmdUI *pCmdUI)
{
    pCmdUI->Enable(TRUE);
	CString str;
    CRiSCAN2DDoc* pDoc = (CRiSCAN2DDoc*)GetActiveDocument();
    str.Format(_T(" Rotation :   %.2f rad"), pDoc->m_dRotate);
	pCmdUI->SetText(str); 
}


/*************************************************************************
 *
 * void OnUpdateDimension(CCmdUI* pCmdUI)
 *
 * Parameters:
 *
 * CCmdUI* pCmdUI       - This object represents the menu item or toolbar
 *                        button or other user-interface object that
 *                        generated the command
 *
 * Return value: 
 *
 * Description:
 *
 * This function updates the status bar.
 * 
 *************************************************************************/
void CMainFrame::OnUpdateDimension(CCmdUI *pCmdUI)
{
    pCmdUI->Enable(TRUE);
	CString str;
    CRiSCAN2DDoc* pDoc = (CRiSCAN2DDoc*)GetActiveDocument();
    POSITION pos = pDoc->GetFirstViewPosition();
    CRiSCAN2DView* pView = (CRiSCAN2DView*)pDoc->GetNextView(pos);
    str.Format(_T(" Dimension : %d * %d"), pView->m_nLines, pView->m_nMeas);
	pCmdUI->SetText(str); 
}


/*************************************************************************
 *
 * void OnUpdateLines(CCmdUI* pCmdUI)
 *
 * Parameters:
 *
 * CCmdUI* pCmdUI       - This object represents the menu item or toolbar
 *                        button or other user-interface object that
 *                        generated the command
 *
 * Return value: 
 *
 * Description:
 *
 * This function updates the status bar.
 * 
 *************************************************************************/
void CMainFrame::OnUpdateLines(CCmdUI *pCmdUI)
{
    pCmdUI->Enable(TRUE);
	CString str;
    CRiSCAN2DDoc* pDoc = (CRiSCAN2DDoc*)GetActiveDocument();
    POSITION pos = pDoc->GetFirstViewPosition();
    CRiSCAN2DView* pView = (CRiSCAN2DView*)pDoc->GetNextView(pos);
    str.Format(_T(" Lines : %d"), pView->m_nLinesReceived);
	pCmdUI->SetText(str); 
}


void CMainFrame::OnLogging() 
{
	int i = m_wndLog.GetCheck();
	AfxGetApp()->WriteProfileInt(SECTION, _T("Logging"), i);
    CRiSCAN2DDoc* pDoc = (CRiSCAN2DDoc*)GetActiveDocument();
    pDoc->m_bIsLogging = FALSE;
    pDoc->m_pScanner->Log(FALSE);
}


void CMainFrame::OnEnvelope() 
{
	int i = m_wndEnvelope.GetCheck();
	AfxGetApp()->WriteProfileInt(SECTION, _T("Envelope"), i);
    Invalidate();
}

void CMainFrame::OnMoving(UINT fwSide, LPRECT pRect) 
{
    CFrameWnd::OnMoving(fwSide, pRect);
	
    CRiSCAN2DDoc* pDoc = (CRiSCAN2DDoc*)GetActiveDocument();
    POSITION pos = pDoc->GetFirstViewPosition();
    CRiSCAN2DView* pView = (CRiSCAN2DView*)pDoc->GetNextView(pos);
    pView->m_bEnvelope = TRUE;
}

void CMainFrame::OnSizing(UINT fwSide, LPRECT pRect) 
{
	CFrameWnd::OnSizing(fwSide, pRect);
	
    CRiSCAN2DDoc* pDoc = (CRiSCAN2DDoc*)GetActiveDocument();
    POSITION pos = pDoc->GetFirstViewPosition();
    CRiSCAN2DView* pView = (CRiSCAN2DView*)pDoc->GetNextView(pos);
    pView->m_bEnvelope = TRUE;
}

void CMainFrame::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CFrameWnd::OnActivate(nState, pWndOther, bMinimized);
	
    CRiSCAN2DDoc* pDoc = (CRiSCAN2DDoc*)GetActiveDocument();
    if (pDoc)
    {
        POSITION pos = pDoc->GetFirstViewPosition();
        CRiSCAN2DView* pView = (CRiSCAN2DView*)pDoc->GetNextView(pos);
        pView->m_bEnvelope = TRUE;
    }
}
