// RiSCAN2DDoc.h : interface of the CRiSCAN2DDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RISCAN2DDOC_H__80D2C1C2_B283_45F1_9F7A_CD373B654067__INCLUDED_)
#define AFX_RISCAN2DDOC_H__80D2C1C2_B283_45F1_9F7A_CD373B654067__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum State
{
    Idle  = 0,
    Start = 1,
    Stop  = 2,
};

class CRiSCAN2DDoc : public CDocument
{
protected: // create from serialization only
	CRiSCAN2DDoc();
	DECLARE_DYNCREATE(CRiSCAN2DDoc)

// Attributes
public:
    IScanner3Ptr m_pScanner;
    CPoint m_ptZeroPoint;
    float m_dZoom;
    float m_dRotate;
    CArray<float, float> m_dGrid;
    int m_nCurrentGrid;
    BOOL m_bFileOpen;
    _bstr_t m_bstrFileName;
    State m_eState;
    CBitmap m_bmp;
    CDC m_dc;
    int m_nXGridSize;
    int m_nYGridSize;
    BOOL m_bIsLogging;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRiSCAN2DDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRiSCAN2DDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRiSCAN2DDoc)
	afx_msg void OnSetPorts();
	afx_msg void OnUpdateSetPorts(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileNew(CCmdUI* pCmdUI);
	afx_msg void OnSetScanner();
	afx_msg void OnUpdateSetScanner(CCmdUI* pCmdUI);
	//}}AFX_MSG
    afx_msg void OnStartScanning();
    afx_msg void OnUpdateStartScanning(CCmdUI* pCmdUI);
    afx_msg void OnStopScanning();
    afx_msg void OnUpdateStopScanning(CCmdUI* pCmdUI);
  	afx_msg void OnStartLogging();
    afx_msg void OnUpdateStartLogging(CCmdUI* pCmdUI);
	afx_msg void OnStopLogging();
    afx_msg void OnUpdateStopLogging(CCmdUI* pCmdUI);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RISCAN2DDOC_H__80D2C1C2_B283_45F1_9F7A_CD373B654067__INCLUDED_)
