// RiSCAN2DView.h : interface of the CRiSCAN2DView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RISCAN2DVIEW_H__CB28E440_C366_43F5_98BD_7A858226A67E__INCLUDED_)
#define AFX_RISCAN2DVIEW_H__CB28E440_C366_43F5_98BD_7A858226A67E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CRiSCAN2DView : public CView
{
protected: // create from serialization only
	CRiSCAN2DView();
	DECLARE_DYNCREATE(CRiSCAN2DView)

// Attributes
public:
	CRiSCAN2DDoc* GetDocument();
    CRiSCAN2DDoc* m_pDoc;

    int m_nLines;
    int m_nMeas;
    float* m_pdVertex;
    CPoint m_ptMouseDown;
    BOOL m_bMove;
    BOOL m_bEnvelope;
    int m_nLinesReceived;

// Operations
public:
  	void OnScannerEOF(WPARAM wParam, LPARAM lParam);
	void OnScannerError(WPARAM wParam, LPARAM lParam);
	void OnScannerClose(WPARAM wParam, LPARAM lParam);
	void OnScannerLine(WPARAM wParam, LPARAM lParam);
    void OnScannerFrame(WPARAM wParam, LPARAM lParam);
    void OnScannerOpen(WPARAM wParam, LPARAM lParam);
    void OnScannerStartLog(WPARAM wParam, LPARAM lParam);
    void OnScannerStopLog(WPARAM wParam, LPARAM lParam);
    void SetGridSize(int nWidth, int nHeight);
    void EraseGrid();
    void PaintGrid();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRiSCAN2DView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL
    afx_msg LRESULT OnScannerNotify(WPARAM wParam, LPARAM lParam);

// Implementation
public:
	virtual ~CRiSCAN2DView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRiSCAN2DView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPaint();
	//}}AFX_MSG
    afx_msg void OnUpdateNext(CCmdUI* pCmdUI);
    afx_msg void OnUpdateRun(CCmdUI* pCmdUI);
    afx_msg void OnZoomPlus();
    afx_msg void OnZoomPlus10();
    afx_msg void OnZoomMinus();
    afx_msg void OnZoomMinus10();
    afx_msg void OnRotateLeft();
    afx_msg void OnRotateRight();
    afx_msg void OnGridPlus();
    afx_msg void OnGridMinus();
    afx_msg void OnNext();
    afx_msg void OnRun();
    afx_msg void OnOptimize();
    afx_msg void OnUpdateOptimize(CCmdUI* pCmdUI);
    DECLARE_MESSAGE_MAP()

private:
	void* m_pHeader;
	void* m_pLineRaw;
	unsigned char* m_pLine;
	int m_nLineSize;
	double m_dTiltAngleZ;
	double m_dTiltAngleY;
};

#ifndef _DEBUG  // debug version in RiSCAN2DView.cpp
inline CRiSCAN2DDoc* CRiSCAN2DView::GetDocument()
   { return (CRiSCAN2DDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RISCAN2DVIEW_H__CB28E440_C366_43F5_98BD_7A858226A67E__INCLUDED_)
